#include "gen.h"
#include <stdio.h>
#include <fcntl.h>

Local char  esc = '\033';
Local char	ctl_z = '\032';

main( argc, argv )
int	argc;
char * argv[];
	{
	FILE *  fd;
	int	rc;
	char * pattern;

	while( --argc )
		{
		if( (*++argv)[0] == '-' )
			switch( (*argv)[1] )
				{
				default:
					fprintf( stderr, "invalid argument %s\n", *argv );
					exit(1);
				}
		else
			break;
		}

	if( argc == 0 )
		{
		fprintf( stderr, "usage: fgrep pattern [file ...]\n" );
		exit(1);
		}

	pattern = *argv++;
	argc--;

	rc = 0;
	if( argc == 0 )
		{
		rc = fgrep( NULL, pattern, stdin );
		exit( 0 );
		}
	else
	while( argc-- )
		{

		if( (fd = fopen( *argv, "r" )) == NULL )
			fprintf( stderr, "couldn't open %s\n", *argv );
		else
			{
			rc |= fgrep( *argv, pattern, fd );
			close( fd );
			}
		argv++;

		}

	exit( !rc );
	}


fgrep( file, pattern, fd )
char	* file;
char	* pattern;
FILE *	fd;
	{
	char	line[BUFSIZ];
	int		rc;

	rc = 0;
	while( fgets( line, sizeof(line), fd ) != NULL )
		if( rc = match( pattern, line ) )
			printf( "%s: %s", (file) ? file : "stdin", line );

	return( rc );

	}

match( pattern, line )
char	* pattern;
char	* line;
	{
	/*  not a great algorithm  */
	char	* ptr;
	char	* end;
	int	plen = strlen(pattern);
	int llen = strlen(line);

	if( plen > llen )
		return( 0 );

	end = line+(llen-plen);

	for( ptr=line; ptr < end; ptr++ )
		{
		if( strncmp( pattern, ptr, plen ) == 0 )
			return( 1 );
		}

	return( 0 );
	}
